#!/usr/bin/perl -w
# calcwts version 1.0

print "What is the root name of the scores files?
(hint: number.rootname):\n";
$rootname=<STDIN>;
chomp $rootname;
print "How many bootstrap resamplings did you do with seqboot?\n";
$bootnum=<STDIN>;
chomp $bootnum;

for ($bootcounter = 1; $bootcounter <= $bootnum; $bootcounter++) {
     $bootlikesname="${bootcounter}.${rootname}";
     open(BOOTLIKESNAME, "${bootlikesname}");
     @alltreeslikes=<BOOTLIKESNAME>;
     close(BOOTLIKESNAME);
     shift @alltreeslikes;
     @alltreeslikesclean = grep { s/\d+\s+(\d+\.\d+)/-$1/ } @alltreeslikes;
     $numtrees=@alltreeslikesclean;
#print "$numtrees\n";

#sort log-likelihoods by descending numerical value and capture ML value
     sub numerically { $b <=> $a; }
     @sortedalltreeslikes = sort numerically @alltreeslikesclean;
     $likemax = shift @sortedalltreeslikes;
#print "${likemax}\n\n";
#print @sortedalltreeslikes;
#print @alltreeslikesclean;
#calculate exp of differences
     foreach $fucker (@alltreeslikesclean) {
     $expdifflikes=exp($fucker - $likemax);
     $expdifftrunc="${expdifflikes}\n";
#print $expdifftrunc;
     push @expdifftruncs, "${expdifftrunc}"; 
   }
@expdifftrunclean= grep { s/^\s*(\S*\.*\d+)/$1/ } @expdifftruncs;
#print @expdifftrunclean;
#sum up the exponential differences
     $sum=0;
     foreach $element (@expdifftrunclean) {
     $sum=${element}+$sum;
     }
#print $sum;
#calculate the likelihood weights     
     foreach $element1 (@expdifftrunclean) {
     $likeweight = ${element1}/$sum;
     push @likeweights, "${likeweight}\n";
   }

#write weights to files
           
     open(LIKEWEIGHTS, ">${bootcounter}.weights");
     print LIKEWEIGHTS @likeweights;
     close(LIKEWEIGHTS);
     push(@list_likeweights, [ @likeweights ]);
#empty arrays
@likeweights=();
@expdifftruncs=();

print "Likelihood weights for bootstrap #${bootcounter} have been written to a file.\n";
}

for ($treecounter=0; $treecounter<$numtrees; $treecounter++) {
$bootsum=0;
$bootweight=0;
for ($finalbtcounter=0; $finalbtcounter<$bootnum; $finalbtcounter++) {
$bootsum= $list_likeweights[${finalbtcounter}][${treecounter}] + $bootsum;
}
$bootweight=$bootsum/$bootnum;
push @bootweights, "${bootweight}\n";
}
@cleanbtwts= grep { s/^\s*(\S*\.*\S+)/$1/ } @bootweights;
#write bootstrap average likelihood weights to files
#and calculate the Bayesian credible set 
     open(BOOTWEIGHTS, ">${rootname}.elw");
     print BOOTWEIGHTS @cleanbtwts;
     close(BOOTWEIGHTS);
print "Expected likelihood weights have been written to ${rootname}.elw.\n";

@sortedbtwts = sort numerically @cleanbtwts;
$cumulative=0;
push @finalstuff, "Tree\t\tPosterior Probability\tCumulative posterior probability
---------------------------------------------------------------------------\n";
foreach $goshdarn (@sortedbtwts) {
$cumulative= ${goshdarn}+$cumulative;
$fingerit= `grep -n \'${goshdarn}\' ${rootname}.elw`;
$fingerit=~s/(\d+):.*/$1/;
chomp $fingerit;
chomp $goshdarn;
if (${fingerit}<100) { 
$newelement="Tree ${fingerit}\t\t${goshdarn}\t${cumulative}\n";
}
else {
$newelement="Tree ${fingerit}\t${goshdarn}\t${cumulative}\n";
}
push @finalstuff, "${newelement}";
}
open(FINALSTUFF, ">${rootname}.elw.summary");
print FINALSTUFF @finalstuff;
close(FINALSTUFF);
print "A summary of the analysis has been written to ${rootname}.elw.summary.\n";
print "Done!\n";
exit 0;
