#!/usr/bin/perl -w
#Load up variables with filenames
print "What kind of data is this - dna (d), rna (r) or protein (p)?
(hint: answer d, r or p - dna is default):\n";
$datatoggle=<STDIN>;
chomp $datatoggle;
if (${datatoggle} eq "r") { $datatype="rna";}
elsif (${datatoggle} eq "p") { $datatype="protein";}
else { $datatype="dna";}
print "What is the name of the file containing the bootstrapped data?
(hint: the name of the SEQUENTIAL FORMAT seqboot output file)\n";
$seqbootfil=<STDIN>;
chomp $seqbootfil;
print "Enter the name of the paup block file you wish to insert
between the bootstrapped datasets:\n";
$paupblock=<STDIN>;
chomp $paupblock;
print "Enter the name of the file containing the trees you wish to test:\n";
$trees=<STDIN>;
chomp $trees;

#Load up arrays with data
open(SEQBOOT, "${seqbootfil}") || die "Cannot open ${seqbootfil}"; 
@seqbootout=<SEQBOOT>;
close(SEQBOOT);
open(PAUPBLOCK, "${paupblock}") || die "Cannot open ${paupblock}";
@paupblockarray=<PAUPBLOCK>;
close(PAUPBLOCK);
#$paupblockline = join('', @paupblockarray);
grep s/(gettrees.*file=).*/$1 ${trees};/, @paupblockarray;

#reformat for paup and insert data block
grep s/\s*(\d+)\s+(\d+)\s*/begin data;\n dimensions ntax=$1 nchar=$2;\n format datatype=${datatype} interleave=no gap=-;\n matrix\n/g, @seqbootout;

#start splicing things together and counting 
$bigline = join('', @seqbootout);
@newseqbootout = split(/(begin data;)/, ${bigline});
shift @newseqbootout;
$counter=1;
open(NEWOUT, ">${seqbootfil}.nexus") || die "Cannot 'write' ${seqbootfil}.nexus";
print NEWOUT "#NEXUS\n";
foreach $element (@newseqbootout) {
  if ($element=~ m/begin data;/) { print NEWOUT "\n\n${element}"; }
  else { print NEWOUT ${element};
         print NEWOUT "\;\nend\;\n";
         grep s/(scorefile=).*\s(replace;*)/$1 ${counter}.${seqbootfil}.scores $2/, @paupblockarray;
         print NEWOUT @paupblockarray;
         ${counter}++;}
}
#close NEWOUT and write to file
close(NEWOUT);
print "Done you Bayesian Akaike freq! Results printed to ${seqbootfil}.nexus\n";
exit 0;
